package com.xingchen.netty.global;

import io.netty.channel.Channel;
import io.netty.channel.ChannelId;
import io.netty.channel.group.ChannelGroup;
import io.netty.channel.group.DefaultChannelGroup;
import io.netty.handler.codec.http.websocketx.TextWebSocketFrame;
import io.netty.util.concurrent.GlobalEventExecutor;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.ConcurrentMap;

public class ChannelSupervise_bak {
   private static ChannelGroup GlobalGroup;
   private static ConcurrentMap<String, ChannelId> ChannelMap;

   public static boolean addChannel(Channel channel) {
      GlobalGroup.add(channel);
      String cid = channel.id().asShortText();
      ChannelMap.put(cid, channel.id());
      return true;
   }

   public static boolean removeChannel(Channel channel) {
      GlobalGroup.remove(channel);
      String cid = channel.id().asShortText();
      ChannelMap.remove(cid);
      return true;
   }

   public static Channel findChannel(String id) {
      ChannelId cid = (ChannelId)ChannelMap.get(id);
      return cid != null ? GlobalGroup.find(cid) : null;
   }

   public static boolean send2All(TextWebSocketFrame tws) {
      GlobalGroup.writeAndFlush(tws);
      return true;
   }

   public static boolean send(String cid, TextWebSocketFrame tws) {
      Channel channel = findChannel(cid);
      if (channel != null) {
         channel.writeAndFlush(tws);
         return true;
      } else {
         return false;
      }
   }

   static {
      GlobalGroup = new DefaultChannelGroup(GlobalEventExecutor.INSTANCE);
      ChannelMap = new ConcurrentHashMap();
   }
}
